diff --git a/plugins/gtkui/callbacks.c b/plugins/gtkui/callbacks.c
index ca71965bfa..1862d54533 100644
--- a/plugins/gtkui/callbacks.c
+++ b/plugins/gtkui/callbacks.c
@@ -237,7 +237,9 @@ void
 on_order_linear_activate               (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
 {
-    deadbeef->streamer_set_shuffle (DDB_SHUFFLE_OFF);
+    if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(menuitem))) {
+        deadbeef->streamer_set_shuffle (DDB_SHUFFLE_OFF);
+    }
 }
 
 
@@ -245,21 +247,27 @@ void
 on_order_shuffle_activate              (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
 {
-    deadbeef->streamer_set_shuffle (DDB_SHUFFLE_TRACKS);
+    if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(menuitem))) {
+        deadbeef->streamer_set_shuffle (DDB_SHUFFLE_TRACKS);
+    }
 }
 
 void
 on_order_shuffle_albums_activate       (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
 {
-    deadbeef->streamer_set_shuffle (DDB_SHUFFLE_ALBUMS);
+    if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(menuitem))) {
+        deadbeef->streamer_set_shuffle (DDB_SHUFFLE_ALBUMS);
+    }
 }
 
 void
 on_order_random_activate               (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
 {
-    deadbeef->streamer_set_shuffle (DDB_SHUFFLE_RANDOM);
+    if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(menuitem))) {
+        deadbeef->streamer_set_shuffle (DDB_SHUFFLE_RANDOM);
+    }
 }
 
 
@@ -267,7 +275,9 @@ void
 on_loop_all_activate                   (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
 {
-    deadbeef->streamer_set_repeat (DDB_REPEAT_ALL);
+    if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(menuitem))) {
+        deadbeef->streamer_set_repeat (DDB_REPEAT_ALL);
+    }
 }
 
 
@@ -275,7 +285,9 @@ void
 on_loop_single_activate                (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
 {
-    deadbeef->streamer_set_repeat (DDB_REPEAT_SINGLE);
+    if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(menuitem))) {
+        deadbeef->streamer_set_repeat (DDB_REPEAT_SINGLE);
+    }
 }
 
 
@@ -283,7 +295,9 @@ void
 on_loop_disable_activate               (GtkMenuItem     *menuitem,
                                         gpointer         user_data)
 {
-    deadbeef->streamer_set_repeat (DDB_REPEAT_OFF);
+    if (gtk_check_menu_item_get_active(GTK_CHECK_MENU_ITEM(menuitem))) {
+        deadbeef->streamer_set_repeat (DDB_REPEAT_OFF);
+    }
 }
 
 gboolean
